unit GSF;

interface

uses
 Graph;

var
 FontLoaded : Boolean;

procedure WriteStr(x, y : Integer; s : string);

function GetWidthStr(s : string) : Integer;

implementation

type
 TFontMatrixTable = array [0..255, 0..7] of Byte;
 TFontWidthTable = array [0..255] of Byte;
 TFont = record
  FontMatrixTable : TFontMatrixTable;
  FontWidthTable  : TFontWidthTable;
 end;
 TFontFile = file of TFont;

var
 FontFile   : TFontFile;
 Font       : TFont;
 k,
 j,
 i          : Byte;
 WS         : Integer;

procedure WriteChar(x, y : Integer; Ch : Char);
begin
 for i := 0 to 5 do
  for j := 0 to Font.FontWidthTable[Ord(Ch)] do
   if (Font.FontMatrixTable[Ord(Ch), i] and (128 shr j)) <> 0 then
     PutPixel(x + j, y + i, GetColor);
end;

procedure WriteStr(x, y : Integer; s : string);
begin
 if FontLoaded then
  begin
   WS := 0;
   for k := 1 to Length(s) do
    begin
     WriteChar(x + WS, y, s[k]);
     WS := WS + Font.FontWidthTable[Ord(s[k])] + 1;
    end;
  end;
end;

function GetWidthStr(s : string) : Integer;
begin
 if FontLoaded then
  begin
   WS := 0;
   for k := 1 to Length(s) do
    WS := WS + Font.FontWidthTable[Ord(s[k])] + 1;
  end;
 GetWidthStr := WS;
end;

begin
 FontLoaded := False;
 Assign(FontFile, 'GS.FF');
 {$I-}
 Reset(FontFile);
 {$I+}
 if IOResult = 0 then
  begin
   Read(FontFile, Font);
   Close(FontFile);
   FontLoaded := True;
  end;
end.